#ifndef BOBINE_H
#define BOBINE_H

#include "barriere.h"
#include <Arduino.h>

/********************************************************
classe qui herite de barrier pour des barrieres de type bobines
constructeur :
    pin bobine ouvrante
    pin bobine fermante
    cde : niveau actif des bobines
    activation : duree de l'activation des bobines
    delai : attente apres passage du train pour ouvrir la barriere
M�thodes redefinies :
    void ouverture() : ouvre la barriere
    void fermeture() : ferme la barriere
    void manoeuvre() : simulation de la manoeuvre d'ouverture

***********************************************************/

class bobine : public barriere
{
    public:
        bobine();
        // le constructeur
        bobine(int pina, int pinb,bool cde, int activation, int delai);
        // le destructeurs
        virtual ~bobine();
        // renvoie les pin de commande des barrieres
        int broche(int num) {switch(num) {
                                case 1 : {return pin1; break;}
                                case 2 : {return pin2;break;}
                                default : return 0;
                                }}
        // la methode ouverture de la barriere
        void ouverture();
        // la methode fermeture de la barriere
        void fermeture();
        // la methode manoeuvre de la barriere
        void manoeuvre();
    protected:
    private:
         // temps d'attente après passage du train
        int attente;
         // pins de commande
        int pin1;
        int pin2;
        // niveau de commande des pins
        int _cde;
};

#endif // BOBINE_H
