#include "relais.h"

// le constructeur

relais::relais() : barriere() {}

/***********************************************************************************
parametres :
    ouvre : pin de commande d'ouverture
    ferme : pin de commande de fermeture
    cde : niveau d'activation
    time : duree de la manoeuvre
*****************************************************************************/

relais::relais(int pina, int pinb,bool cde, int duree): barriere(duree,2), pin1(pina), pin2(pinb){
 _cde = cde;
pinMode(pin1,OUTPUT); digitalWrite(pin1,!_cde);
pinMode(pin2,OUTPUT); digitalWrite(pin2,!_cde);
}

// le destructeur
relais::~relais(){}

/*****************************************************************
OUVERTURE : methode d'initialisation d'ouverture de la barriere
******************************************************************/

void relais::ouverture() {
if (!ouverte()) {
    _actif = true;               // on est actif
    timer = millis();           // on arme la duree de la manoeuvre
    sens = montee;              // on monte les barrieres
    situation = encours;        // manoeuvre en cours
    }
}

/*********************************************************************
FERMETURE : methode d'initialisation de la fermeture de la barriere
************************************************************************/

void relais::fermeture() {
if (!fermee()) {
    _actif = true;               // on est actif
    timer = millis();           // on arme la duree de la manoeuvre
    sens = descente;            // on descend la barriere
    situation = encours;        // manoeuvre en cours
    }
}

/*******************************************************************************
MANOEUVRE : phases de manoeuvre de la barriere (ouverture et fermeture)
*********************************************************************************/

void relais::manoeuvre() {
if (_actif){                                         // si on est actif
    if ((timer + duree) > millis()) {               // si on n'a pas depasse le temps de manaoeuvre
            switch(sens){                           // suivant le sens (montee, descente)
            case montee : {digitalWrite(pin1,_cde); digitalWrite(pin2,!_cde);break;}   // on alimente les relais montant
            case descente : {digitalWrite(pin1,!_cde); digitalWrite(pin2,_cde);break;} // on alimente les relais descendant
             }
    }
    else {                                          // si on a depasse le temps de manoeuvre
        if (sens == montee){situation = ouvert;} else {situation = ferme;}  // on note la situation de la barriere
        sens = arret;                                                       // on ne manoeuvre plus
        _actif = false;                                                      // on n'est plus actif
        digitalWrite(pin1,!_cde); digitalWrite(pin2,!_cde);          // on coupe les relais
     }
  }
}
